// NEO PIXEL STICK 8 AUDIO LEVEL METER <STEREO> v0.99
// UZURATAMAGO @uzurannn

#include <Adafruit_NeoPixel.h>

//data output pin
#define PIN 6

//input sensitivity
#define sens 4

// Parameter 1 = number of pixels in strip
// Parameter 2 = Arduino pin number (most are valid)
// Parameter 3 = pixel type flags, add together as needed:
//   NEO_KHZ800  800 KHz bitstream (most NeoPixel products w/WS2812 LEDs)
//   NEO_KHZ400  400 KHz (classic 'v1' (not v2) FLORA pixels, WS2811 drivers)
//   NEO_GRB     Pixels are wired for GRB bitstream (most NeoPixel products)
//   NEO_RGB     Pixels are wired for RGB bitstream (v1 FLORA pixels, not v2)
Adafruit_NeoPixel strip = Adafruit_NeoPixel(16, PIN, NEO_GRB + NEO_KHZ800);

// IMPORTANT: To reduce NeoPixel burnout risk, add 1000 uF capacitor across
// pixel power leads, add 300 - 500 Ohm resistor on first pixel's data input
// and minimize distance between Arduino and first pixel.  Avoid connecting
// on a live circuit...if you must, connect GND first.

void setup()
{
    strip.begin();
    strip.setBrightness(90);
    strip.show(); // Initialize all pixels to 'off'
}

void loop()
{
    uint32_t c;
    
    uint32_t cR = strip.Color(255, 0, 0);
    uint32_t cG = strip.Color(0, 255, 0);
    uint32_t c0 = strip.Color(0, 0, 0);
    
    static int levL_1;
           int levL_2;
           
    static int levR_1;
           int levR_2;
           
    static int dwnEn;
    
    int valL;
    int valR;
    
    int direcL;
    int direcR;
    
    int posL_1;
    int posR_1;
    
    int posL_2;
    int posR_2;

    int i;
    
    valL = analogRead(5);
    valR = analogRead(4);

         if(valL < 1 * sens){levL_2 = 0;}
    else if(valL < 2 * sens){levL_2 = 1;}
    else if(valL < 3 * sens){levL_2 = 2;}
    else if(valL < 4 * sens){levL_2 = 3;}
    else if(valL < 5 * sens){levL_2 = 4;}
    else if(valL < 6 * sens){levL_2 = 5;}
    else if(valL < 7 * sens){levL_2 = 6;}
    else if(valL < 8 * sens){levL_2 = 7;}
    else                    {levL_2 = 8;}
    
         if(levL_2 < levL_1){direcL = -1;}
    else if(levL_2 > levL_1){direcL =  1;}
    
         if(valR < 1 * sens){levR_2 = 0;}
    else if(valR < 2 * sens){levR_2 = 1;}
    else if(valR < 3 * sens){levR_2 = 2;}
    else if(valR < 4 * sens){levR_2 = 3;}
    else if(valR < 5 * sens){levR_2 = 4;}
    else if(valR < 6 * sens){levR_2 = 5;}
    else if(valR < 7 * sens){levR_2 = 6;}
    else if(valR < 8 * sens){levR_2 = 7;}
    else                    {levR_2 = 8;}
    
         if(levR_2 < levR_1){direcR = -1;}
    else if(levR_2 > levR_1){direcR =  1;}
    
    if(direcL == -1 && dwnEn == 0)
    {
        posL_1 = levL_1 - 1;
        c = c0;
        
        strip.setPixelColor(posL_1, c);
        strip.show();
        
        levL_1--;
    }
    else if(direcL == 1)
    {
        posL_1 = levL_1 - 1;
        posL_2 = levL_2 - 1;
        
        for(i = posL_1 + 1; i <= posL_2; i++)
        {
            if(i <= 4)
            {
                c = cG;
            }
            else if(i >= 5 && i <= 7)
            {
                c = cR;
            }
            strip.setPixelColor(i, c);
            strip.show();
        }
        levL_1 = levL_2;
    }
    
    if(direcR == -1 && dwnEn == 0)
    {
        posR_1 = levR_1 - 1 + 8;
        c = c0;
        
        strip.setPixelColor(posR_1, c);
        strip.show();
        
        levR_1--;
    }
    else if(direcR == 1)
    {
        posR_1 = levR_1 - 1 + 8;
        posR_2 = levR_2 - 1 + 8;
        
        for(i = posR_1 + 1; i <= posR_2; i++)
        {
            if(i >= 8 && i <= 12)
            {
                c = cG;
            }
            else if(i >= 13 && i <= 15)
            {
                c = cR;
            }
            strip.setPixelColor(i, c);
            strip.show();
        }
        levR_1 = levR_2;
    }
    
    dwnEn++;
    if(dwnEn == 50)
    {
        dwnEn = 0;
    }
    
    delay(1);
}

